#!/usr/bin/env php
<?php
error_reporting(0);
set_time_limit(0);

/*
 * Note: I could use mhash_count() here but I like to see unavailable hashers
 * because this is important to me to choose the most-available hasher(s) and
 * those with the best speed/secure tradeoff.
 */
$hasher = hash_algos();

$timers = array();
$count = 500 * 1000;

print 'Iterating ' . $count . 'x over all ' . count($hasher) . ' hash functions ...' . "\r\n";

foreach ($hasher as $hash) {
	$time = microtime(true);
	for ($idx = 0; $idx <= $count; $idx++) {
		$dummy = hash($hash, 'hash-test-abc-123-foo-bar');
	}

	$timers[$hash] = (microtime(true) - $time);
	print '.';
}

print "\r\n\r\n";
asort($timers);

print 'Result from hash() benchmark (in seconds per hasher):' . "\r\n";
print_r($timers) . "\n";
