<?php
// Own namespace
namespace Org\Mxchange\CoreFramework\Database\Frontend\Points;

// Import framework stuff
use Org\Mxchange\CoreFramework\Database\Frontend\DatabaseFrontend;
use Org\Mxchange\CoreFramework\Result\Update\UpdateableResult;

/**
 * An interface for frontend dealing with bookable points
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2021 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface BookablePointsFrontend extends DatabaseFrontend {
	/**
	 * Inserts the given points for the given user in the database
	 *
	 * @param	$pointsInstance		An instance of a user class
	 * @return	void
	 */
	function insertUserPoints (BookablePoints $pointsInstance);

	/**
	 * Updates an user database entry with given result
	 *
	 * @param	$resultInstance		An instance of a UpdateableResult class
	 * @return	void
	 */
	function doUpdateByResult (UpdateableResult $resultInstance);

}
